function A=metesub(A,pto,S)

% METESUB introduce una submatriz S de tamao m*n entorno al pto [i j] de 
% la matriz A.
%
% Se introduce segun:
%
%     Si m,n son pares:   
%
%          A(i-floor(m/2)+1:i+floor(m/2),j-floor(n/2)+1:j+floor(n/2))=S
%
%     Si m,n son impares:   
%
%          A(i-ceil(m/2)+1:i+ceil(m/2)-1,j-ceil(n/2)+1:j+ceil(n/2)-1)=S
%
% NOTAS:
%     
%   * Si m y n son impares el pto [i j] queda en el centro de la submatriz,
%     sino, queda mas cerca del extremo superior izquierdo. 
%
%   * En el caso de que el subbloque que queremos introducir sobrepase los li-
%     mites de A, solo se modifican las 'partes afectadas' de A (de forma que
%     el punto [i j] de A queda en el centro del subbloque (centro en el sen-
%     tido anterior).
%
%   * Si las componentes [i j] del punto central no son enteras, se introduce 
%     en la posicion floor([i j]).
%
% USO: B=metesub(A,[i j],subbloque);

a=size(A);
i=pto(1);
j=pto(2);
s=size(S);
m=s(1);
n=s(2);
pto=floor(pto);
i=floor(i);
j=floor(j);  
if floor(m/2)<m/2
   mf=i-ceil(m/2)+1;
   Mf=i+ceil(m/2)-1;
else
   mf=i-floor(m/2)+1;
   Mf=i+floor(m/2);
end
if floor(n/2)<n/2
   mc=j-ceil(n/2)+1;
   Mc=j+ceil(n/2)-1;
else
   mc=j-floor(n/2)+1;
   Mc=j+floor(n/2);
end
if (mf<1)|(Mf>a(1))|(mc<1)|(Mc>a(2))
   if (mf>a(1))|(Mf<1)|(mc>a(2))|(Mc<1)    
          A=A;
   elseif ((mf<1)&(mc<1))&((Mf>=1)&(Mc>=1))
          fi=1-mf+1;
          ci=1-mc+1;
          A(1:m-fi+1,1:n-ci+1)=S(fi:m,ci:n);
   elseif ((mf<1)&(Mc>=a(2)))&((Mf>=1)&(mc<=a(2)))
          fi=1-mf+1;
          cf=n-(Mc-a(2));
          A(1:m-fi+1,a(2)-cf+1:a(2))=S(fi:m,1:cf);
   elseif ((Mf>a(1))&(mc<1))&((mf<=a(1))&(Mc>=1))
          ci=1-mc+1;
          ff=m-(Mf-a(1));
          A(a(1)-ff+1:a(1),1:n-ci+1)=S(1:ff,ci:n);
   elseif ((Mf>a(1))&(Mc>a(2)))&((mf<=a(1))&(mc<=a(2)))
          cf=n-(Mc-a(2));
          ff=m-(Mf-a(1));
          A(a(1)-ff+1:a(1),a(2)-cf+1:a(2))=S(1:ff,1:cf);
   elseif (mf<1)&((Mf>=1)&(mc>=1)&(Mc<=a(2)))
          fi=1-mf+1;
          A(1:m-fi+1,mc:Mc)=S(fi:m,1:n);
   elseif (mc<1)&((Mc>=1)&(mf>=1)&(Mf<=a(1)))
          ci=1-mc+1;
          A(mf:Mf,1:n-ci+1)=S(1:m,ci:n);
   elseif (Mf>a(1))&((mf<=a(1))&(mc>=1)&(Mc<=a(2)))
          ff=m-(Mf-a(1));
          A(a(1)-ff+1:a(1),mc:Mc)=S(1:ff,1:n);
   elseif (Mc>a(2))&((mc<=a(2))&(mf>=1)&(Mf<=a(1)))
         cf=n-(Mc-a(2));
         A(mf:Mf,a(2)-cf+1:a(2))=S(1:m,1:cf);
   end
else
   A(mf:Mf,mc:Mc)=S;
end
