function [ciaf,logciaf]=ngan(fc,N)

% NGAN da la CSF que utiliza Ngan (Opt. Eng. 1991) para 
% pesar los coef. de la DCT 
%
% USO: [ciaf,logciaf]=ngan(fc,num_ptos);

f=linspace(0,fc,N);
H=(0.31+0.69*f).*exp(-0.29*f);
A=(1/4+(1/pi^2)*(log(2*pi*f/11.636+sqrt(4*pi^2*f.^2/11.636^2+1))).^2).^(1/2);
ciaf=A.*H;
logciaf=log(A.*H)/log(2);