function [dctf]=icontra2(s,Lm,Ncuan,norm)

% ICONTRA2 deshace la normalizacion de contraste de CONTRAS2 para pasar a amplitud en una DCT local
% Podemos elegir entre diferentes normalizaciones:
%
%   Norm = 1 ......... Normalizamos mediante la luminancia media del subbloque considerado.
%
%   Norm = 2 ......... Normalizamos mediante la luminancia media del subbloque considerado y
%                      de los subbloques del entorno. Hay que introducir como parametro que
%                      numero de subbloques queremos tomar de entorno.
%
%   Norm = 3 ......... Normalizamos mediante la luminancia media de toda la imagen.
%
%   Norm = 4 ......... Normalizamos mediante el valor (de luminancia) introducido como parametro
%                      (valor*l^2), donde l es el lado del subbloque de las DCTs locales. 
% 
% NOTA: Al hablar de luminancia nos referimos a la magnitud en la que este expresada la imagen
%       de entrada. Salvo calibracion, la imagen de entrada suele expresarse en 'niveles de gris',
%       no estrictamente en luminancia.
%
% DE MOMENTO SOLO NORMALIZACIONES 1 y 3 (que incluye a la 4 -ver CONTRAS2-)
% 
% USO: [dct_amplitud]=icontrast(dct_contraste,Lm,Ncuan,[Norm parametro]);
%  
   
   par=norm(2);
   norm=norm(1);
   tam=size(s);
   tam=tam(1);
   lados=[tam tam];

   dctf=zeros(tam,tam);

   lcuan=tam/(2^Ncuan);
   
   cc=zeros(lcuan,lcuan);
   for i=1:lcuan
       for j=1:lcuan
        ddd=zeros(lcuan,lcuan);
        ddd(1,1)=1;
        ddd(i,j)=1;
        est_dct=idct2(ddd);
        % max(max(est_dct))
        % min(min(est_dct))
        cc(i,j)=(max(max(est_dct))-min(min(est_dct)))/(max(max(est_dct))+min(min(est_dct)));
        % [i j (max(max(est_dct))-min(min(est_dct)))/(max(max(est_dct))+min(min(est_dct)))]
        % pause
       end
   end    
   
   
   posai=[tam tam]/2-round(tam/2);
   posbd=[tam tam]/2+round(tam/2);
   coorcuanai=floor([(posai(1)-1)/lcuan+1 (posai(2)-1)/lcuan+1]);
   coorcuanbd=floor([(posbd(1)-1)/lcuan+1 (posbd(2)-1)/lcuan+1]);
   if coorcuanai(1)<1
        coorcuanai(1)=1;
   end 
   if coorcuanai(2)<1
        coorcuanai(2)=1;
   end 
   if coorcuanbd(1)>(2^Ncuan)
        coorcuanbd(1)=2^Ncuan;
   end     
   if coorcuanai(2)>(2^Ncuan)
        coorcuanbd(2)=2^Ncuan;
   end 
      
   
   for ii=coorcuanai(1):coorcuanbd(1)
       for jj=coorcuanai(2):coorcuanbd(2)
    
           iii=(ii-1)*lcuan+ceil(lcuan/2);
           jjj=(jj-1)*lcuan+ceil(lcuan/2); 
           blo=sacasub(s,[iii jjj],[lcuan lcuan],0);

           dctc=blo;

%              if norm==1
%                 cub(2:lcuan,1)=2*cub(2:lcuan,1)/cub(1,1);
%                 cub(1,2:lcuan)=2*cub(1,2:lcuan)/cub(1,1);
%                 cub(2:lcuan,2:lcuan)=4*cub(2:lcuan,2:lcuan)/cub(1,1);
%%                cub(1,1)=cub(1,1)/(4*lcuan^2);
%                 Lm(ii,jj)=cub(1,1)/lcuan;

              cubs(1,1)=Lm(ii,jj)*lcuan;
 
              if norm==1
%                  dctc(2:lcuan,1)=dctc(2:lcuan,1)*cubs(1,1)/2;
%                  dctc(1,2:lcuan)=dctc(1,2:lcuan)*cubs(1,1)/2;
%                  dctc(2:lcuan,2:lcuan)=dctc(2:lcuan,2:lcuan)*cubs(1,1)/4;
                 cc(1,1)=1;
                 dctc=cubs(1,1)*dctc./cc;
                 dctc(1,1)=cubs(1,1);
   %           elseif norm==2
   %              dctc(2:lcuan,1)=dctc(2:lcuan,1)*Lmedia/2;
   %              dctc(1,2:lcuan)=dctc(1,2:lcuan)*Lmedia/2;
   %              dctc(2:lcuan,2:lcuan)=dctc(2:lcuan,2:lcuan)*Lmedia/4;
   %              dctc(1,1)=cub(1,1);
               elseif norm==3
                 Lmedia=par;  
                 cubs11=Lmedia*lcuan;
                 cc(1,1)=1;
                 dctc=cubs11*dctc./cc;
                 dctc(1,1)=cubs(1,1);
                 
%                  dctc(2:lcuan,1)=dctc(2:lcuan,1)*cubs11/2;
%                  dctc(1,2:lcuan)=dctc(1,2:lcuan)*cubs11/2;
%                  dctc(2:lcuan,2:lcuan)=dctc(2:lcuan,2:lcuan)*cubs11/4;
%                  dctc(1,1)=cubs(1,1);
   %           elseif norm==4
   %              dctc(2:lcuan,1)=dctc(2:lcuan,1)*(4*par*lcuan^2)/2;
   %              dctc(1,2:lcuan)=dctc(1,2:lcuan)*(4*par*lcuan^2)/2;
   %              dctc(2:lcuan,2:lcuan)=dctc(2:lcuan,2:lcuan)*(4*par*lcuan^2)/4;
   %              dctc(1,1)=cub(1,1);
   %           else
   %              dctc(2:lcuan,1)=2*dctc(2:lcuan,1);
   %              dctc(1,2:lcuan)=2*dctc(1,2:lcuan);
              end

%           if fla==1
%              dctc(1,1)=0;
%              cod(1,1)=0;
%           end

           dctf=metesub(dctf,[iii jjj],dctc);

       end 
   end
