function s=idct2r(s,Ncuan)

% IDCT2R calcula la IDCT2D de los subbloques (de una resolucion espacial) de una DCT2D
% a resolucion R calculada con DCR2R.
% 
% USO: IDCT2r=idct2r(seal,nivel de resolucion espacial) 
%
% Ojo!!: usar solo sobre seales con frames cuadrados de lado 2^b
%  
   
   tam=size(s);
   tam=tam(1);
   pto=[tam tam]/2;
   lados=[tam tam];
   lcuan=tam/(2^Ncuan);
   posai=pto-round(lados/2);
   posbd=pto+round(lados/2);
   coorcuanai=floor([(posai(1)-1)/lcuan+1 (posai(2)-1)/lcuan+1]);
   coorcuanbd=floor([(posbd(1)-1)/lcuan+1 (posbd(2)-1)/lcuan+1]);
   if coorcuanai(1)<1
        coorcuanai(1)=1;
   end 
   if coorcuanai(2)<1
        coorcuanai(2)=1;
   end 
   if coorcuanbd(1)>(2^Ncuan)
        coorcuanbd(1)=2^Ncuan;
   end 
   if coorcuanai(2)>(2^Ncuan)
        coorcuanbd(2)=2^Ncuan;
   end

   for ii=coorcuanai(1):coorcuanbd(1)
       for jj=coorcuanai(2):coorcuanbd(2)
           iii=(ii-1)*lcuan+ceil(lcuan/2);
           jjj=(jj-1)*lcuan+ceil(lcuan/2);
           cub=sacasub(s,[iii jjj],[lcuan lcuan],0);
           dctcub=idct2(cub);
           s=metesub(s,[iii jjj],dctcub);
       end
   end
