function [R,CSF2D]=respue_lineal(dctinic,k1)
   
% 
% RESPUE_LINEAL calcula la respuesta lineal a una DCT2D local
% (expresada en contraste)
% 
%   DCTn(f) = CSF(f) DCT(f) 
% 
% A esta funcion se han de pasar los parametros de la respuesta 
% CSF (solo la depend. en frecuencia, es decir, tal como los da naka100.m) 
%
% Devuelve:
% 
%  La respuesta, Resp
%  El parametro CSF en forma de matriz, CSF2D
%
% NOTA: Se supone que el bloque que se mete en la funcion ya esta expresado en
%       contrastes (ver CONTRAST)
%
% USO:
% 
% [Resp,CSF2D]=respue_lineal(dctinic,CSF)
% 
  
% Tamanyo de la entrada (esto es una chorrada porque todo debe casar con H... supongo 16*16)
      
   tam=size(dctinic);
   tam=tam(1);
   lados=[tam tam];
   
% Lado de los subbloques locales
     
   lcuan=lados(1);
 
% Paso a 2D y posterior reordenacion 1D de las constantes que provienen de NAKA100.M
    
   k1=simrev(k1);
   k1=zigzag(k1);   
   
   alfa=k1;
   
%%%%%%%%%%%%%%%%%%%%%%%%%%
          
              cub=dctinic;
              
           % Ordenacion 1D del bloque
              
              cub=zigzag(cub);
              
           % Desplazamiento del origen para evitar singularidades
              
              cub=abs(cub);
                            
           % Respuesta
              
              R=k1.*cub;
              R(1)=sqrt(cub(1));
              
           % Reordenacion 2D de la respuesta

              R=dezigzag(R);

              CSF2D=k1;