function p=pos_w_pyr(coor_wt,ind)

% POS_W_PYR da la posicion (en el vector PYR) del coeficiente wavelet solicitado
% 
% Se asume la ordenacion de los coeficientes que se usa en matlabpyrtools,
% es decir, ordenacion de escalas de fina a grosera, ordenacion de orientaciones 
% horizontal, vertical y diagonal, ordenacion de las posiciones por
% columnas (como en reshape, no como en raster!).
%
% Por tanto:
%
%   - La escala va desde 1 (la mas fina) hasta k (la mas grosera)
%   - La orientacion puede valer: 1 (horizontal), 2 (vertical) o 3 (diagonal)
%   - La posicion (filas o columnas) puede ir desde 1 hasta N/(2^escala)
%
% p=pos_w_pyr([escala orientacion fila columna],ind)

% s=size(ind);
% num_escalas=(s(1)-1)/3;

escala=coor_wt(1);
orient=coor_wt(2);
fil=coor_wt(3);
col=coor_wt(4);

banda=(escala-1)*3+orient;

if banda>1
   indices=pyrBandIndices(ind,banda-1);
else
   indices=0;    
end

p=indices(end)+posicion([col fil],ind(banda,:));