function MPE = dist_r_achrom(pyr,pyrR,ind,datos)

% Datos de la respuesta no lineal
extended = datos.extended;


% Dimensiones de la imagen
Nf = sqrt(length(pyr));
Nc = Nf;





if(extended == 2)
    
    % Extraemos los datos de interes
    escalas = datos.escalas;
    sigma_e = datos.sigma_e;
    sigma_o = datos.sigma_o;
    sigma_xy = datos.sigma_xy;
    umbral = datos.umbral;
    Ao_y = datos.Ao_y;
    Ao_uv = datos.Ao_uv;
    sigma_hv_y = datos.sigma_hv_y;
    sigma_hv_uv = datos.sigma_hv_uv;
    sigma_d_y = datos.sigma_d_y;
    sigma_d_uv = datos.sigma_d_uv;
    theta = datos.theta;

    alfas = generacion_alfas_v2([Ao_y Ao_uv],[sigma_hv_y sigma_hv_uv],...
        [sigma_d_y sigma_d_uv],theta,escalas);

    % Convertimos los 'double' en 'string' para cargar la matriz
    se = num2str(sigma_e);
    so = num2str(sigma_o);
    sxy = num2str(sigma_xy);
    tamanyo = num2str(Nf);
    s_umbral = num2str(umbral);

    indice = findstr(se,'.');
    se(indice) = '_';

    indice = findstr(so,'.');
    so(indice) = '_';

    indice = findstr(sxy,'.');
    sxy(indice) = '_';

    % Cargamos la matriz H (h_sparse)
    cd '/home/masimo/Ajuste Medida Distorsion/Kernels/Optimizados/H256/';
    load(['h_' tamanyo '_se_' se '_so_' so '_sxy_' sxy '_umbral_' s_umbral]);
    
    g1 = datos.g1;
    beta = datos.beta;
    
    r = respuesta_no_lineal(pyr,ind,alfas,extended,g1,beta,h_sparse);
    rR = respuesta_no_lineal(pyrR,ind,alfas,extended,g1,beta,h_sparse);
    
    % Eliminamos la continua de la respuesta
    tam_cont = Nf *Nc / 2^(2*escalas);

    r  = r(1:end-tam_cont,:);
    rR = rR(1:end-tam_cont,:);

    % Calculo de las distancias perceptuales
    dr = abs(r(:) - rR(:));

    % Calculo del error perceptual como la suma cuadratica de las distancias
    % perceptuales
    MPE = sqrt(sum(dr.^2)/numel(dr));
    
end