function alfas = generacion_alfas(Ao,sigma_hv,sigma_d,expon,escalas)

% Genera los perfiles CSF de acuerdo con la funcion descrita en 'Rango de
% valores.pdf'
%
% Ao       -> Valor constante                                   [20  -  80]
% sigma_hv -> Controla la anchura de la gaussiana en las orientaciones
%             horizontal(1) y vertical (2)                      [1.5 - 3.5]
% sigma_d  -> Controla la anchura de la gaussiana en la orientacion
%             diagonal(3)                                       [1.5 - 3.5]
% expon    -> Exponente para controlar la forma de la funcion   [1.5 -  10]
% escalas  -> Numero de escalas utilizadas en la transformada Wavelet   [4]


alfas = zeros(escalas,3,3);

for escala = 1:escalas % HF --- LF
    
    sigma = sigma_hv;
    
    for orientacion = 1:3 % H V D        
        
        if(orientacion == 3)
            
            sigma = sigma_d;
            
        end

        alfa_i = Ao .* exp( - ( (escalas - escala) / sigma ) ^ expon );
        
        alfas(escala,orientacion,1) = alfa_i;
        
    end
    
end

alfas(:,:,2) = alfas(:,:,1);
alfas(:,:,3) = alfas(:,:,1);